#!/usr/bin/perl -w
#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: hosting.cgi,v 1.12 2004/02/01 09:20:05 fuktommy Exp $
#

use lib qw(..);
use Shingetsu::Config;

umask $Shingetsu::Config::umask;

$filedir	= $Shingetsu::Config::filedir;

if ($ENV{QUERY_STRING} ne "") {
	$path = $ENV{QUERY_STRING};
} elsif (defined $ENV{PATH_INFO}) {
	$path = $ENV{PATH_INFO};
	$path =~ s|^/||;
} else {
	$path = "";
}

if ($path =~ m|^([-0-9A-Za-z._]+)$|) {
	printFile($1);

} else {
	print404();
}

#------------------------------------------------------------------#

#
# print CGI header and File contents
#
sub printFile {
	my($file) = @_;
	my $ver = $Shingetsu::Config::version;
	$file =~ /\.([^.]+)$/;
	my $suffix = $1;
	$suffix = "txt" unless (defined $suffix);
	my $type = $Shingetsu::Config::mimeType{$suffix};
	$type = "text/plain" unless (defined $type);
	print "Content-Type: $type\r\n",
	      "X-Shingetsu: shinGETsu/$ver\r\n",
	      "\r\n";
	if ((-f "$filedir/$file")&&(open IN, "$filedir/$file")) {
		print <IN>;
		close IN;
	} else {
		print404();
	}
}

#
# print CGI header (404 not found)
#
sub print404 {
	my $ver = $Shingetsu::Config::version;
	print "Content-Type: text/plain\r\n",
	      "X-Shingetsu: shinGETsu/$ver\r\n",
	      "\r\n",
	      "Bar arguments or No data.\n",
	      "Try later.\n";
}
